/*
 * JS for orders_sel generated by Appery.io
 *
 */

Appery.getProjectGUID = function() {
    return '650da51c-7b87-423e-b67d-61d28cf28805';
}

function navigateTo(outcome, useAjax) {
    Appery.navigateTo(outcome, useAjax);
}

function adjustContentHeight() {
    Appery.adjustContentHeight();
}

function adjustContentHeightWithPadding() {
    Appery.adjustContentHeightWithPadding();
}

function setDetailContent(pageUrl) {
    Appery.setDetailContent(pageUrl);
}

Appery.AppPages = [{
    "name": "order_pdet",
    "location": "order_pdet.html"
}, {
    "name": "Order_New_Line",
    "location": "Order_New_Line.html"
}, {
    "name": "update_error",
    "location": "update_error.html"
}, {
    "name": "test_pb",
    "location": "test_pb.html"
}, {
    "name": "orders_sel",
    "location": "orders_sel.html"
}, {
    "name": "Camera",
    "location": "Camera.html"
}, {
    "name": "orders_list",
    "location": "orders_list.html"
}, {
    "name": "Camera_cl2",
    "location": "Camera_cl2.html"
}, {
    "name": "order_details",
    "location": "order_details.html"
}, {
    "name": "customer_details",
    "location": "customer_details.html"
}, {
    "name": "Products",
    "location": "Products.html"
}, {
    "name": "start_menu",
    "location": "start_menu.html"
}, {
    "name": "product",
    "location": "product.html"
}, {
    "name": "Order_New_Line2",
    "location": "Order_New_Line2.html"
}, {
    "name": "startScreen",
    "location": "startScreen.html"
}, {
    "name": "order_detail_edit",
    "location": "order_detail_edit.html"
}, {
    "name": "Customers",
    "location": "Customers.html"
}, {
    "name": "customer_edit",
    "location": "customer_edit.html"
}, {
    "name": "create_order",
    "location": "create_order.html"
}];

orders_sel_js = function(runBeforeShow) { /* Object & array with components "name-to-id" mapping */
    var n2id_buf = {
        'addnew': 'orders_sel_addnew',
        'mobilegrid_13': 'orders_sel_mobilegrid_13',
        'mobilegridcell_14': 'orders_sel_mobilegridcell_14',
        'mobilegridcell_15': 'orders_sel_mobilegridcell_15',
        'orders_slct': 'orders_sel_orders_slct',
        'month_orders': 'orders_sel_month_orders',
        'mobilelistitembutton_10': 'orders_sel_mobilelistitembutton_10'
    };

    if ("n2id" in window && window.n2id !== undefined) {
        $.extend(n2id, n2id_buf);
    } else {
        window.n2id = n2id_buf;
    }

    if (navigator.userAgent.indexOf("IEMobile") != -1) {
        //Fixing issue https://github.com/jquery/jquery-mobile/issues/5424 on Windows Phone
        $("div[data-role=page] div[data-role=footer]").css("bottom", "-36px");
    }

    if (Appery.getTargetPlatform == "I") {
        $.each(window.n2id, function(name, id) {
            var elApperyRole = $("#" + id).attr("data-role");
            if (elApperyRole != "appery_label" && elApperyRole != "appery_link") {
                var appleDataSelector = "#" + id + "[x-apple-data-detectors], #" + id + " [x-apple-data-detectors]";
                $(appleDataSelector).attr("x-apple-data-detectors", "false");
            }
        });
    }

    Appery.CurrentScreen = 'orders_sel';

    /*
     * Nonvisual components
     */
    var datasources = [];

    select_orders = new Appery.DataSource(orders_select, {
        'onComplete': function(jqXHR, textStatus) {

            $t.refreshScreenFormElements("orders_sel");
        },
        'onSuccess': function(data) {},
        'onError': function(jqXHR, textStatus, errorThrown) {},
        'responseMapping': [{
            'PATH': ['data', 'orders_select'],
            'ID': 'month_orders',
            'SET': [{
                'PATH': ['ordmonth'],
                'ID': 'month_orders',
                'ATTR': '@',
                'SUBSELECTOR': 'h3.ui-li-heading'
            }]
        }],
        'requestMapping': [{
            'PATH': ['Authorization'],
            'TYPE': 'STRING',
            'HEADER': true,
            'ID': '___local_storage___',
            'ATTR': 'authorization_string'
        }, {
            'PATH': ['url'],
            'TYPE': 'STRING',
            'ID': '___local_storage___',
            'ATTR': 'url'
        }]
    });

    datasources.push(select_orders);

    /*
     * Events and handlers
     */

    // Before Show
    orders_sel_beforeshow = function() {
        Appery.CurrentScreen = "orders_sel";
        for (var idx = 0; idx < datasources.length; idx++) {
            datasources[idx].__setupDisplay();
        }
    }

    // On Load
    screen_137B_onLoad = orders_sel_onLoad = function() {
        screen_137B_elementsExtraJS();

        // TODO fire device events only if necessary (with JS logic)
        orders_sel_deviceEvents();
        orders_sel_windowEvents();
        screen_137B_elementsEvents();
    }

    // screen window events
    screen_137B_windowEvents = orders_sel_windowEvents = function() {

        $('#orders_sel').bind('pageshow orientationchange', function() {
            adjustContentHeightWithPadding();
        });
        $('#orders_sel').bind({
            pageshow: function() {
                try {
                    select_orders.execute({})
                } catch (ex) {
                    console.log(ex.name + '  ' + ex.message);
                    hideSpinner();
                };
                //alert(localstorage.getItem('new_order'));
            },
        });

    }

    // device events
    orders_sel_deviceEvents = function() {

        document.addEventListener("deviceready", function() {

        });
    }

    // screen elements extra js
    screen_137B_elementsExtraJS = orders_sel_elementsExtraJS = function() {
        // screen (orders_sel) extra code

        /* orders_slct */

        listView = $("#orders_sel_orders_slct");
        theme = listView.attr("data-theme");
        if (typeof theme !== 'undefined') {
            var themeClass = "ui-btn-up-" + theme;
            listItem = $("#orders_sel_orders_slct .ui-li-static");
            $.each(listItem, function(index, value) {
                $(this).addClass(themeClass);
            });
        }

        /* month_orders */

    }

    // screen elements handler
    screen_137B_elementsEvents = orders_sel_elementsEvents = function() {

        $("a :input,a a,a fieldset label").live({
            click: function(event) {
                event.stopPropagation();
            }
        });

        $('#orders_sel_mobilecontainer [name="addnew"]').die().live({
            click: function() {
                if (!$(this).attr('disabled')) {
                    Appery.navigateTo('create_order', {
                        transition: 'pop'
                    });

                }
            },
        });

        $('#orders_sel_mobilecontainer [name="month_orders"]').die().live({
            click: function() {
                if (!$(this).attr('disabled')) {
                    setVar_('month_string', 'orders_sel_month_orders', 'text', '', this);
                    Appery.navigateTo('orders_list', {
                        reverse: false
                    });

                }
            },
        });

    }

    $("#orders_sel").die("pagebeforeshow").live("pagebeforeshow", function(event, ui) {
        orders_sel_beforeshow();
    });

    if (runBeforeShow) {
        orders_sel_beforeshow();
    } else {
        orders_sel_onLoad();
    }

}

$("#orders_sel").die("pageinit").live("pageinit", function(event, ui) {
    Appery.processSelectMenu($(this));
    orders_sel_js();
});