/*
 * JS for StartApp generated by Appery.io
 *
 */

Appery.getProjectGUID = function() {
    return '1c0ae847-f0fd-4b68-97b2-853cc35aa54f';
}

function navigateTo(outcome, useAjax) {
    Appery.navigateTo(outcome, useAjax);
}

function adjustContentHeight() {
    Appery.adjustContentHeight();
}

function adjustContentHeightWithPadding() {
    Appery.adjustContentHeightWithPadding();
}

function setDetailContent(pageUrl) {
    Appery.setDetailContent(pageUrl);
}

Appery.AppPages = [{
    "name": "EditService",
    "location": "EditService.html"
}, {
    "name": "ApiPage",
    "location": "ApiPage.html"
}, {
    "name": "test",
    "location": "test.html"
}, {
    "name": "StartPage",
    "location": "StartPage.html"
}, {
    "name": "StartScreen",
    "location": "StartScreen.html"
}, {
    "name": "table_details",
    "location": "table_details.html"
}, {
    "name": "servicelist",
    "location": "servicelist.html"
}, {
    "name": "Database",
    "location": "Database.html"
}, {
    "name": "StartApp",
    "location": "StartApp.html"
}, {
    "name": "serverinformation",
    "location": "serverinformation.html"
}];

$(document).bind('scroll', function() {
    adjustContentHeight();
});
$(window).bind(window.orientation ? 'orientationchange' : 'resize', function() {
    adjustContentHeight();
});

StartApp_js = function(runBeforeShow) { /* Object & array with components "name-to-id" mapping */
    var n2id_buf = {
        'DataButton': 'StartApp_DataButton',
        'spacer_4': 'StartApp_spacer_4',
        'RASButton': 'StartApp_RASButton',
        'spacer_5': 'StartApp_spacer_5',
        'SDButton': 'StartApp_SDButton',
        'spacer_6': 'StartApp_spacer_6',
        'mobileimage_7': 'StartApp_mobileimage_7'
    };

    if ("n2id" in window && window.n2id !== undefined) {
        $.extend(n2id, n2id_buf);
    } else {
        window.n2id = n2id_buf;
    }

    if (navigator.userAgent.indexOf("IEMobile") != -1) {
        //Fixing issue https://github.com/jquery/jquery-mobile/issues/5424 on Windows Phone
        $("div[data-role=footer]").css("bottom", "-36px");
    }

    Appery.CurrentScreen = 'StartApp';

    /*
     * Nonvisual components
     */
    var datasources = [];

    /*
     * Events and handlers
     */

    // Before Show
    StartApp_beforeshow = function() {
        Appery.CurrentScreen = "StartApp";
        for (var idx = 0; idx < datasources.length; idx++) {
            datasources[idx].__setupDisplay();
        }
    }

    // On Load
    screen_3B84_onLoad = StartApp_onLoad = function() {
        screen_3B84_elementsExtraJS();

        // TODO fire device events only if necessary (with JS logic)
        StartApp_deviceEvents();
        StartApp_windowEvents();
        screen_3B84_elementsEvents();
    }

    // screen window events
    screen_3B84_windowEvents = StartApp_windowEvents = function() {
        $('#StartApp').bind('pageshow orientationchange', function() {
            adjustContentHeightWithPadding();
        });

    }

    // device events
    StartApp_deviceEvents = function() {

        document.addEventListener("deviceready", function() {

        });
    }

    // screen elements extra js
    screen_3B84_elementsExtraJS = StartApp_elementsExtraJS = function() {
        // screen (StartApp) extra code

    }

    // screen elements handler
    screen_3B84_elementsEvents = StartApp_elementsEvents = function() {

        $("a :input,a a,a fieldset label").live({
            click: function(event) {
                event.stopPropagation();
            }
        });

        $('#StartApp_mobilecontainer [name="DataButton"]').die().live({
            click: function() {
                if (!$(this).attr('disabled')) {
                    Appery.navigateTo('Database', {
                        reverse: false
                    });

                }
            },
        });

        $('#StartApp_mobilecontainer [name="RASButton"]').die().live({
            click: function() {
                if (!$(this).attr('disabled')) {
                    Appery.navigateTo('ApiPage', {
                        reverse: false
                    });

                }
            },
        });

        $('#StartApp_mobilecontainer [name="SDButton"]').die().live({
            click: function() {
                if (!$(this).attr('disabled')) {
                    setDetailContent('serverinformation.html');

                }
            },
        });

    }

    $("#StartApp").die("pagebeforeshow").live("pagebeforeshow", function(event, ui) {
        StartApp_beforeshow();
    });

    if ($(window).width() >= 650) {
        var fixed = true;

        jQuery(document).ready(function($) {
            $('.ui-content').addClass("width_gt_650");

            if (navigator.platform == 'iPad' || navigator.platform == 'iPhone' || navigator.platform == 'iPod') {
                $(".content-secondary").css("position", "absolute");
                fixed = false;
            } else {
                $(".content-secondary").css("position", "fixed");
            }

            $(".content-secondary").css("float", "left");
            $(".content-secondary").css("left", "0px");
            var heightEl = $(".ui-header:visible");
            $(".content-secondary").css("top", heightEl.outerHeight() ? heightEl.outerHeight() : 0 + "px");
            $(".content-secondary").css("z-index", "999");
            $(".content-secondary").css("border", "0px solid red");

            adjustContentHeight();
        });

        $('.content-secondary input, .content-secondary textarea').unbind('blur', adjustContentHeight);
        $('.content-secondary input, .content-secondary textarea').bind('blur', adjustContentHeight);

        $("#StartApp").bind("pageshow", function(event) {
            var $page = $(this);
            $page.find(":jqmData(scroll):not(.ui-scrollview-clip)").each(function() {
                var $this = $(this);
                // XXX: Remove this check for ui-scrolllistview once we've
                //      integrated list divider support into the main scrollview class.
                if ($this.hasClass("ui-scrolllistview")) $this.scrolllistview();
                else {
                    var st = $this.jqmData("scroll") + "";
                    var paging = st && st.search(/^[xy]p$/) != -1;
                    var dir = st && st.search(/^[xy]/) != -1 ? st.charAt(0) : null;

                    var opts = {};
                    if (dir) opts.direction = dir;
                    if (paging) opts.pagingEnabled = true;

                    var method = $this.jqmData("scroll-method");
                    if (method) opts.scrollMethod = method;

                    $this.scrollview(opts);
                }
            });
        });

    }
    $("#StartApp").bind('pageshow', function() {
        setDetailContent('StartPage.html')
    });

    if (runBeforeShow) {
        StartApp_beforeshow();
    } else {
        StartApp_onLoad();
    }

}

$("#StartApp").die("pageinit").live("pageinit", function(event, ui) {
    Appery.processSelectMenu($(this));
    StartApp_js();
});